/* Written by Tony J. Podrasky - W6ESE - 07 December 2006 */
/* e-mail address: W6ESE@arrl.org */
 
#include    <stdio.h>                                           /* standard I/O file */
#include    <stdlib.h>                                          /* standard library */
#include    <string.h>                                          /* string library */
#include    <unistd.h>                                          /* symbolic constants */
#include    <fcntl.h>                                           /* function control */
#include    <sys/types.h>                                       /* function control */
#include    <sys/stat.h>                                        /* function control */
#include    <sys/time.h>                                        /* time function */
#include    <unistd.h>                                          /* UNIx STanDard header */ 

#define     DATAIN      "/dev/ttyS0"                            /* Input file */
#define     DATAOUT     "/dev/ttyS0"                            /* Output file */
#define     MEMORYBANK  "orion_memorybank"                      /* Orion MEMORY BANK file */
#define     BUFFERSIZE  8192                                    /* work buffer size for data stream */

int main (void)                                                 /* beginning of program */
    {
    fd_set  rfds;                                               /* read offset for file descriptor */

    FILE    *memorybank;                                        /* file pointer to [MEMORYBANK] */

    int     i;                                                  /* scratch integer for memory loop */
    int     xlatcurptr = 0;                                     /* xlation buffer current pointer value */
    int     xlatmaxsze = 0;                                     /* xlation buffer maximum pointer value */
    int     datain;                                             /* file pointer to data in file */
    int     dataout;                                            /* file pointer to data out file */
    int     mem_begin = 1;                                      /* first memory location */
    int     mem_end = 200;                                      /* last memory location */
    int     interrupt;                                          /* output from SELECT function */
    int     mode = 0;                                           /* test to see if we store to memory or not */
    int     semaphore = 0;                                      /* test int for memory file writing */
    int     lfcounter = 0;                                      /* test int for line feeds in data stream */

    char    xlation[BUFFERSIZE];                                /* data stream buffer using during upload */
    char    buffer;                                             /* character storage area */
    char    ttychar;                                            /* buffer for incoming character */
    char    LF = '\n';                                          /* ASCII LINE FEED */
    char    CR = '\r';                                          /* ASCII CARRIAGE RETURN */
    char    TAB = '\t';                                         /* ASCII TAB */
    char    SPACE = ' ';                                        /* ASCII SPACE */
    char    STAR = '*';                                         /* ASCII ASTERISK */
    char    COLON = ':';                                        /* ASCII COLON */
    char    HOOK = '\?';                                        /* ASCII QUESTION MARK */
    char    AT = '@';                                           /* ASCII AT sign */
    char    B = 'B';                                            /* ASCII B */
    char    D = 'D';                                            /* ASCII D */
    char    F = 'F';                                            /* ASCII F */
    char    K = 'K';                                            /* ASCII K */
    char    M = 'M';                                            /* ASCII M */
    char    R = 'R';                                            /* ASCII R */
    char    S = 'S';                                            /* ASCII S */
    char    T = 'T';                                            /* ASCII T */
    char    U = 'U';                                            /* ASCII U */
    char    W = 'W';                                            /* ASCII W */
    char    X = 'X';                                            /* ASCII X */
    char    MLH = '0';                                          /* Memory Location Hundred's */
    char    MLT = '0';                                          /* Memory Location Ten's */
    char    MLO = '1';                                          /* Memory Location One's */
    char    MLSEED = '0';                                       /* Character to reset MLx to ASCII 0 */
    char    FPH = '0';                                          /* File Position Hundred's */
    char    FPT = '0';                                          /* File Position Ten's */
    char    FPO = '1';                                          /* File Position One's */
    char    FPSEED = '0';                                       /* Character to reset FPx to ASCII 0 */

    system("/bin/stty -F /dev/ttyS0 57600 crtscts -echo");      /* | system call to stty to set port parms | */
    system("/bin/stty -icanon ");                               /* | set tty port to single-character mode | */

    if ((datain = open(DATAIN, O_RDONLY, 0)) == -1)             /* | create file pointer to tty port   | */
        {                                                       /* |                                   | */
        printf("\nERROR: can't open: %s \n", DATAIN);           /* | error out if file can't be opened | */
        return 0;                                               /* |                                   | */
        }                                                       /* |                                   | */

    if ((dataout = open(DATAOUT, O_WRONLY, 0)) == -1)           /* | create file pointer to tty port   | */
        {                                                       /* |                                   | */
        printf("\nERROR: can't open: %s \n", DATAOUT);          /* | error out if file can't be opened | */
        return 0;                                               /* |                                   | */
        }                                                       /* |                                   | */

    printf("\n");                                               /* | start a new line for the text message   | */
    printf("[T]est communication to the ORION / ");             /* | to send data to the transceiver or get  | */
    printf("[U]pload data to the ORION / ");                    /* | send data to console asking if you want | */
    printf("[D]ownload data from the ORION / ");                /* | to send data to the transceiver or get  | */
    printf("[<TAB>] key to exit utility\n");                    /* | data from the transceiver. Use TAB key  | */
    printf("Enter [T] [U] [D] or [TAB]: \n");                   /* | to exit utility                         | */

    while(1)                                                    /* BEGINNING OF ACTUAL PROGRAM */
        {
        FD_ZERO(&rfds);                                         /* | zero out bits in rfds field        | */
        FD_SET(0, &rfds);                                       /* | set bits in keyboard rfds field    | */
        FD_SET(datain, &rfds);                                  /* | set bits in serial port rfds field | */

        interrupt = select(4, &rfds, NULL, NULL, NULL);         /* set select interrupt */

        if (FD_ISSET(0, &rfds))                                 /* | see if a key was pressed      | */
            {                                                   /* | if so, then get a character   | */
            (void) read(STDIN_FILENO, &buffer, 1);              /* | from the keyboard             | */

            if (buffer == TAB)                                  /* | see if the character is a TAB | */
                {                                               /* | if so, do the following       | */
                close(datain);                                  /* | close the datain file         | */
                close(dataout);                                 /* | close the dataout file        | */
                printf("\nEnd Program Called\n\n");             /* | print message to screen       | */
                return 0;                                       /* | close the program             | */
                }                                               /* | end of program                | */

            if (buffer == T)                                    /* | see if the character is a T. if so | */
                {                                               /* | send query sequence to the ORION   | */
                mode = 0;                                       /* disable writing to memorybank */

                (void) write(dataout, &X, 1);                   /* | send command sequence to the ORION | */
                (void) write(dataout, &X, 1);                   /* | send command sequence to the ORION | */
                (void) write(dataout, &CR, 1);                  /* | send command sequence to the ORION | */
                }

            if (buffer == D)                                    /* | see if the character is a D. if so | */
                {                                               /* | run the download sequence.         | */
                printf("\nBeginning Download from Orion\n");    /* | print message                      | */

                mode = 1;                                       /* enable writing to memorybank */

                if ((memorybank = fopen(MEMORYBANK, "w")) == NULL)          /* | create file pointer to the memory  | */
                    {                                                       /* | bank file. if it can't be opened   | */
                    printf("\nERROR: can't open file: %s \n", MEMORYBANK);  /* | error out                          | */
                    return 0;                                               /* |                                    | */
                    }                                                       /* |                                    | */

                for(i = mem_begin; i <= mem_end; ++i)           /* | setup the download sequence parameters    | */
                    {
                    (void) write(dataout, &STAR, 1);            /* | command sequence to select memory channel | */
                    (void) write(dataout, &K, 1);               /* | command sequence to select memory channel | */
                    (void) write(dataout, &R, 1);               /* | command sequence to select memory channel | */
                    (void) write(dataout, &B, 1);               /* | command sequence to select memory channel | */
                    (void) write(dataout, &MLH, 1);             /* | command sequence to select memory channel | */
                    (void) write(dataout, &MLT, 1);             /* | command sequence to select memory channel | */
                    (void) write(dataout, &MLO, 1);             /* | command sequence to select memory channel | */
                    (void) write(dataout, &CR, 1);              /* | command sequence to select memory channel | */

                    (void) write(dataout, &HOOK, 1);            /* | command sequence to get frequency  | */
                    (void) write(dataout, &B, 1);               /* | command sequence to get frequency  | */
                    (void) write(dataout, &F, 1);               /* | command sequence to get frequency  | */
                    (void) write(dataout, &CR, 1);              /* | command sequence to get frequency  | */
                
                    (void) write(dataout, &HOOK, 1);            /* | command sequence to get bandwidth  | */
                    (void) write(dataout, &R, 1);               /* | command sequence to get bandwidth  | */
                    (void) write(dataout, &S, 1);               /* | command sequence to get bandwidth  | */
                    (void) write(dataout, &F, 1);               /* | command sequence to get bandwidth  | */
                    (void) write(dataout, &CR, 1);              /* | command sequence to get bandwidth  | */
                
                    (void) write(dataout, &HOOK, 1);            /* | command sequence to get mode | */
                    (void) write(dataout, &R, 1);               /* | command sequence to get mode | */
                    (void) write(dataout, &S, 1);               /* | command sequence to get mode | */
                    (void) write(dataout, &M, 1);               /* | command sequence to get mode | */
                    (void) write(dataout, &CR, 1);              /* | command sequence to get mode | */

                    MLO = MLO+1;                                /* bump memory channel pointer */

                    if (MLO == COLON)                           /* | see if we bumped it past ASCII 9 | */
                        {                                       /* | which is an ASCII COLON. if so,  | */
                        MLO = MLSEED;                           /* | reset the ONES pointer to 0 and  | */
                                                                /* | bump the TENS pointer. Now see   | */
                        MLT = MLT+1;                            /* | if we bumped the TENS pointer    | */
                                                                /* | past ASCII 9. if so reset the    | */
                        if (MLT == COLON)                       /* | TENS point to 0 and bump the     | */
                            {                                   /* | HUNDREDS pointer.                | */
                            MLT = MLSEED;                       /* |                                  | */
                            MLH = MLH+1;                        /* |                                  | */
                            }                                   /* |                                  | */
                        }                                       /* |                                  | */
                    }
                }

            if (buffer == U)                                                /* | see if the character is a U. if so | */
                {                                                           /* | we will upload  data to the Orion. | */
                if ((memorybank = fopen(MEMORYBANK, "r")) == NULL)          /* | create file pointer to the memory  | */
                    {                                                       /* | bank file. if it can't be opened   | */
                    printf("\nERROR: can't open file: %s \n", MEMORYBANK);  /* | error out                          | */
                    return 0;                                               /* |                                    | */
                    }                                                       /* |                                    | */

                while(fscanf(memorybank, "%c", &buffer) == 1)               /* | pull in the data from the orion    | */
                    {                                                       /* | memorybank file.                   | */
                    if (buffer == AT)                                       /* | if the current character is a @    | */
                        {                                                   /* | sign, replace it with an asterisk  | */
                        buffer = STAR;                                      /* |                                    | */
                        }                                                   /* | copy it to the xlation buffer      | */
                    xlation[xlatmaxsze] = buffer;                           /* | bump the pointer value. when done  | */
                    ++xlatmaxsze;                                           /* | xlatemaxsze will become the end of | */
                    }                                                       /* | buffer pointer                     | */

                while(xlatcurptr <= (xlatmaxsze - 1))                       /* | prepare to send data to the Orion  | */
                    {                                                       /* |                                    | */
                    printf("\n");                                           /* |                                    | */
                    MLH = xlation[xlatcurptr];                              /* | copy the first 3 characters of the | */
                    printf("%c", MLH);                                      /* | current line into the buffers for  | */
                    ++xlatcurptr;                                           /* | the hundreds, tens, and ones of    | */
                    MLT = xlation[xlatcurptr];                              /* | the memory location that we will   | */
                    printf("%c", MLT);                                      /* | be loading up with the following   | */
                    ++xlatcurptr;                                           /* | data. print the location numbers   | */
                    MLO = xlation[xlatcurptr];                              /* | to the console so you can see      | */
                    printf("%c ", MLO);                                     /* | what is going on.                  | */
                    ++xlatcurptr;                                           /* |                                    | */
                    
                    ++xlatcurptr;                                           /* bump the pointer past the space character */

                    for (i = 0; i <= 10; ++i)                               /* | send the next 11 characters to the | */
                        {                                                   /* | Orion, which consists of an        | */
                        (void) write(dataout, &xlation[xlatcurptr], 1);     /* | asterisk, a B, an F, and the 8     | */
                        printf("%c", xlation[xlatcurptr]);                  /* | frequency bits. print it to the    | */
                        ++xlatcurptr;                                       /* | console, bump the pointer          | */
                        }                                                   /* |                                    | */

                        printf(" ");                                        /* print a space character to separate the data */

                        (void) write(dataout, &CR, 1);                      /* send a carriage return to lock it in */

                    ++xlatcurptr;                                           /* bump the pointer past the space character */

                    while(xlation[xlatcurptr] != SPACE)                     /* | send the BANDWIDTH data to the | */
                        {                                                   /* | Orion. print it to the console | */
                        (void) write(dataout, &xlation[xlatcurptr], 1);     /* |                                | */
                        printf("%c", xlation[xlatcurptr]);                  /* |                                | */
                        ++xlatcurptr;                                       /* |                                | */
                        }                                                   /* |                                | */

                        printf(" ");                                        /* print a space character to separate the data */

                        (void) write(dataout, &CR, 1);                      /* send a carriage return to lock it in */

                    ++xlatcurptr;                                           /* bump the pointer past the space character */

                    while(xlation[xlatcurptr] != LF)                        /* | send the MODE data to the  | */
                        {                                                   /* | Orion. print it to the     | */
                        (void) write(dataout, &xlation[xlatcurptr], 1);     /* | console                    | */
                        printf("%c", xlation[xlatcurptr]);                  /* |                            | */
                        ++xlatcurptr;                                       /* |                            | */
                        }                                                   /* |                            | */

                        ++xlatcurptr;                                       /* bump the pointer past the space character */

                        (void) write(dataout, &CR, 1);                      /* send a carriage return to lock it in */

                        (void) write(dataout, &STAR, 1);                    /* | take the FREQUENCY, the     | */
                        (void) write(dataout, &K, 1);                       /* | BANDWIDTH, and the MODE     | */
                        (void) write(dataout, &W, 1);                       /* | and write it to the Orion's | */
                        (void) write(dataout, &B, 1);                       /* | memory bank.                | */
                        (void) write(dataout, &MLH, 1);                     /* |                             | */
                        (void) write(dataout, &MLT, 1);                     /* |                             | */
                        (void) write(dataout, &MLO, 1);                     /* |                             | */
                        (void) write(dataout, &CR, 1);                      /* |                             | */
                    }

                close(datain);                          /* | close the datain file     | */
                close(dataout);                         /* | close the dataout file    | */
                fclose(memorybank);                     /* | close the memorybank file | */
                printf("\n\nUpload Complete");          /* | print message to screen   | */
                printf("\n\nEnd Program Called\n\n");   /* | print message to screen   | */
                return 0;                               /* | close the program         | */
                }
            } 


        if (FD_ISSET(datain, &rfds))                            /* | see if the tty port has data | */ 
            {
            (void) read(datain, &ttychar, 1);                   /* if so, read in a character */

            if (mode == 0)                                      /* | test for mode bit. if it is a 0 | */
                {                                               /* | just echo the data to the       | */
                printf("%c", ttychar);                          /* | console.                        | */
                }                                               /* |                                 | */

            if (mode == 1)                                          /* | if mode bit is a 1, we are in     | */
                {                                                   /* | download to memorybank file mode. | */
                if (semaphore == 0)                                 /* | see if the semaphore test flag    | */
                    {                                               /* | is set to 0. if so, we are just   | */
                    fprintf(memorybank, "%c", FPH);                 /* | beginning the copy of the data    | */
                    fprintf(memorybank, "%c", FPT);                 /* | from the Orion to the memorybank. | */
                    fprintf(memorybank, "%c", FPO);                 /* | enter 001 at the beginning of the | */
                    fprintf(memorybank, "%c", SPACE);               /* | first line in the memorybank file | */

                    FPO = FPO+1;                                    /* bump the memorybank line pointer */

                    lfcounter = 1;                                  /* bump the line feed counter */

                    semaphore = 1;                                  /* | set the semaphore to 1 so that the  | */
                    }                                               /* | 0 routine is bypassed from now on.  | */

                if (semaphore == 1)                                 /* | if semaphore is 1, begin download  | */
                    {                                               /* | operation.                         | */
                    if (ttychar == LF)                              /* | see if the rcv'd char is a LF      | */
                        {                                           /* | if so, see how many we've rcv'd    | */
                        if (lfcounter == 3)                         /* | if it's the 3rd one we will begin  | */
                            {                                       /* | a new line and increment the line  | */
                            fprintf(memorybank, "%c", ttychar);     /* | memory counter.                    | */

                            if (FPH == '2' && FPT == '0' && FPO == '1') /* | test to see if we reached the end  | */
                                {                                       /* | of the Orion's memory. if so then  | */
                                close(datain);                          /* | close the datain file              | */
                                close(dataout);                         /* | close the dataout file             | */
                                fclose(memorybank);                     /* | close the memorybank file          | */
                                printf("\nDownload Complete");          /* | print message to screen            | */
                                printf("\nEnd Program Called\n\n");     /* | print message to screen            | */
                                return 0;                               /* | close the program                  | */
                                }

                            fprintf(memorybank, "%c", FPH);         /* | write the memory channel number to | */
                            fprintf(memorybank, "%c", FPT);         /* | the memorybank file.               | */
                            fprintf(memorybank, "%c", FPO);         /* |                                    | */

                            lfcounter = 0;                          /* reset the line feed counter */

                            FPO = FPO+1;                            /* bump memory channel pointer */

                            if (FPO == COLON)                       /* | see if we bumped it past ASCII 9 | */
                                {                                   /* | which is an ASCII COLON. if so,  | */
                                FPO = FPSEED;                       /* | reset the ONES pointer to 0 and  | */
                                                                    /* | bump the TENS pointer. Now see   | */
                                FPT = FPT+1;                        /* | if we bumped the TENS pointer    | */
                                                                    /* | past ASCII 9. if so reset the    | */
                                if (FPT == COLON)                   /* | TENS point to 0 and bump the     | */
                                    {                               /* | HUNDREDS pointer. we won't test  | */
                                    FPT = FPSEED;                   /* | for the value of the HUNDREDS    | */
                                    FPH = FPH+1;                    /* | pointer.                         | */
                                    }
                                }
                            }

                        lfcounter = lfcounter+1;                    /* bump the line feed counter */

                        ttychar = SPACE;                            /* replace the line feed with a space char */
                        }

                    fprintf(memorybank, "%c", ttychar);             /* write data from Orion to memorybank file */
                    }
                }
            }
        }
return 0;
    }
