/* Written by Tony J. Podrasky - W6ESE - 07 December 2006 */
/* e-mail address: W6ESE@arrl.org */

#include    <stdio.h>                                           /* standard I/O file */
#include    <stdlib.h>                                          /* standard library */
#include    <string.h>                                          /* string library */
#include    <unistd.h>                                          /* symbolic constants */
#include    <fcntl.h>                                           /* function control */
#include    <sys/types.h>                                       /* function control */
#include    <sys/stat.h>                                        /* function control */
#include    <sys/time.h>                                        /* time function */
#include    <unistd.h>                                          /* UNIx STanDard header */ 

#define     DATAIN      "/dev/ttyS0"                            /* Input file */
#define     DATAOUT     "/dev/ttyS0"                            /* Output file */

int main (void)                                                 /* beginning of program */
    {
    fd_set  rfds;                                               /* read offset for file descriptor */

    int     datain;                                             /* file pointer to data in file */
    int     dataout;                                            /* file pointer to data out file */
    int     interrupt;                                          /* output from SELECT function */

    char    ttychar;                                            /* buffer for incoming character */
    char    buffer;                                             /* buffer for keyboard character */

    char    XX = 'X';						/* ASCII X */
    char    CR = '\r';						/* ASCII carriage return */


    system("/bin/stty -F /dev/ttyS0 57600 -echo");              /* system call to stty to set port parms */

    system("/bin/stty -icanon ");                               /* set tty port to single-character mode */


    if ((datain = open(DATAIN, O_RDONLY, 0)) == -1)             /* | create file pointer to tty port   | */
        {                                                       /* |                                   | */
        printf("ERROR: can't open: %s \n", DATAIN);             /* | error out if file can't be opened | */
        return 0;                                               /* |                                   | */
        }

    if ((dataout = open(DATAOUT, O_WRONLY, 0)) == -1)           /* | create file pointer to tty port   | */
        {                                                       /* |                                   | */
        printf("ERROR: can't open: %s \n", DATAOUT);            /* | error out if file can't be opened | */
        return 0;                                               /* |                                   | */
        }


    while(1)                                                    /* beginning of actual program */
        {
        FD_ZERO(&rfds);                                         /* | zero out bits in rfds field | */
        FD_SET(0, &rfds);                                       /* | set bits in rfds field      | */
        FD_SET(datain, &rfds);                                  /* | set bits in rfds field      | */

        interrupt = select(4, &rfds, NULL, NULL, NULL);         /* set select interrupt */

        if (FD_ISSET(0, &rfds))                                 /* | see if the console is ready   | */
            {                                                   /* |                               | */
            (void) read(STDIN_FILENO, &buffer, 1);              /* | get a character from keyboard | */

            if (buffer == 9)                                    /* see if the character is a TAB */
                {                                               /* | if so, do the following | */
                close(datain);                                  /* | close the datain file   | */
                close(dataout);                                 /* | close the dataout file  | */
                return 0;                                       /* | close the program       | */
                }

            (void) write(dataout, &XX, 1);                      /* send the character to out the port */
            (void) write(dataout, &XX, 1);                      /* send the character to out the port */
            (void) write(dataout, &CR, 1);                      /* send the character to out the port */

            }



        if (FD_ISSET(datain, &rfds))                            /* | see if the tty port has data | */ 
            {
            (void) read(datain, &ttychar, 1);                   /* if so, read in a character */
                        
            printf("%c", ttychar);                              /* send it to the screen */
            }

        }
return 0;
    }
